//
// Vorlage ist: teVirtualMIDITest.dpr
//
// Diese Unit aus dem Projekt entfernen und das Projekt lsst sich ohne
// "VirtualMidi" generieren.
//
unit UVirtual;

interface

implementation

{$APPTYPE CONSOLE}

uses
  windows,
  SysUtils,
  teVirtualMIDIdll,
  uStuff,
  Midi,
  Forms;

var 
  dummy: word;
  port2: LPVM_MIDI_PORT;
  i: integer;
  s: string;


procedure teVMCallback( MidiPort: LPVM_MIDI_PORT; MidiDataBytes: PBYTE; DataLength: DWORD; dwCallbackInstance: Pointer ); stdcall;
begin
  if ( mididatabytes = nil ) or ( datalength = 0 ) then
    begin
      writeln('empty command - driver was probably shut down!');
      exit;
    end;
  if not virtualMIDISendData( midiport, mididatabytes, datalength ) then
    begin
      writeln('error sending data: '+virtualMIDIError(GetLastError()));
      exit;
    end;
  writeln( 'command: '+ bintostr( mididatabytes, datalength ) );
end;


initialization
  writeln( 'using dll-version:    ' + virtualMIDIGetVersion( dummy, dummy, dummy, dummy ));
  writeln( 'using driver-version: ' + virtualMIDIGetDriverVersion( dummy, dummy, dummy, dummy ));

  virtualMIDILogging( TE_VM_LOGGING_MISC or TE_VM_LOGGING_RX or TE_VM_LOGGING_TX );

  i := 1;
  repeat
    s := 'Midi loopback ' + IntToStr(i);
    inc(i);
  until MidiInput.GetSysDeviceIndex(s) < 0;
  
  port2 := virtualMIDICreatePortEx2( PWideChar(s), teVMCallback, nil, 65535, TE_VM_FLAGS_PARSE_RX );
  if port2=nil then
  begin
    writeln('could not create port2: '+virtualMIDIError(GetLastError()));
  end;
  Sleep(10);
  Application.ProcessMessages;
  MidiInput.GenerateList;

finalization
  if port2 <> nil then
    virtualMIDIClosePort( port2 );
end.
